QGIS Application - Feature request #1727
Support Multiple Rules per Style for a Layer
2009-06-10 09:11 PM - springmeyer -

Status: Closed

Priority: Low

Assignee: nobody -

Category: Symbology

Pull Request or Patch supplied: Resolution: fixed
Easy fix?: No Copied to github as #: 11787
Description

It appears that currently QGIS can only apply one style (or set of 'symbols') to a layer (one2one relationship). But to support proper scale
dependent rendering of layers it will be necessary to allow multiple rules (with their own min/max visibility) to contain sets of symbols and
be applied to a single layer (many2one between style rules-> layer).

This is essentially what all the major web rendering engines support, and well described by the SLD spec (see request for SLD support in
#1167).

The challenge here is not writing the code to process and render multiple rules, but in designing and supporting a good user interface to
expose the ability to edit styles in this way. It is notable that even the new [[GeoExt]] Styler does not yet support this (but has it as a first
item on the roadmap as of June 10,2008):

From http://projects.opengeo.org/styler :*
Symbolizer improvements

In order to support features like roads with outlines, we need the ability to define more than one symbolizer on a rule. Right now there is an
assumption that each rule only has one symbolizer. This is not a constraint of SLD, just on what we've built thus far. The first release of
Styler also does not support all the potential options for SLD strokes and labels. These should be accessible in the Ul, to give users full
control over their output.

Design proposal: Symbolizers
Implementation details: http://projects.opengeo.org/styler/wiki/Symbolizers and http://projects.opengeo.org/styler/ticket/39*

Nevertheless this is an essential feature, that if implemented will bring QGIS to a high level of usefulness for creating mapping styles for
web applications.

History

#1 - 2009-06-10 09:12 PM - springmeyer -

Whoops, meant to link to the SLD request at: #1726

#2 - 2010-03-23 07:45 AM - Jiirgen Fischer

see also #2584

#3 - 2010-06-10 03:51 AM - Martin Dobias

The attached patch rulebasedrenderer_v2.diff adds a rule-based renderer to symbology-ng, together with python bindings and GUI that enables user to
effectively work with the rules.
#4 - 2010-06-12 03:14 AM - Paolo Cavallini

Can this be closed following commit:0a4f1c59 (SVN r13711)?
#5 - 2010-06-12 03:16 AM - Martin Dobias

- Resolution set to fixed

- Status changed from Open to Closed

Files

rulebasedrenderer_v2.diff 54 KB
